<?PHP

/* ====================
Seditio - Website engine
Copyright Neocrome
http://www.neocrome.net

[BEGIN_SED]
File=plugins/userrights/userrights.php
Version=100
Updated=2006-jan-01
Type=Plugin
Author=Neocrome
Description=
[END_SED]

[BEGIN_SED_EXTPLUGIN]
Code=userrights
Part=admin
File=userrights.admin
Hooks=tools
Tags=
Order=10
[END_SED_EXTPLUGIN]
==================== */

if (!defined('SED_CODE')) { die('Wrong URL.'); }

require ('plugins/userrights/lang/userrights.'.$usr['lang'].'.lang.php');
$id = sed_import('id','G','INT');
$userid = sed_import('userid','P','INT');
$id = ($userid>0) ? $userid : $id;
$advanced = sed_import('advanced','G','BOL');
$adv_columns = ($advanced) ? 5 : 0;

if (!$id)
	{
	$askid = TRUE;
	$id = 1;
	}
else
	{
	$askid = FALSE;
	}

function sed_userrights_item($code, $option)
	{
	global $userrights_sec, $L, $cfg;

	if (!empty($userrights_sec[$code][$option]))
		{
		$res = "<td>".$userrights_sec[$code][$option]."</td>";
		}
	else
		{
		if ($code=='plug')
			{
			$res = "<td>".$L['Plugin']." ".$cfg['separator']." ".$option."</td>";
			}
		else
			{
			$res = "<td>".$code." ".$cfg['separator']." ".$option."</td>";
			}
		}

	return($res);
	}

function sed_userrights_rights($rights)
	{
	global $L, $allow_img, $advanced;
	$mn =array();

	$mn['R'] = 1;
	$mn['W'] = 2;

	if ($advanced)
		{
		$mn['1'] = 4;
		$mn['2'] = 8;
		$mn['3'] = 16;
		$mn['4'] = 32;
		$mn['5'] = 64;
		}
	$mn['A'] = 128;

	foreach ($mn as $code => $value)
		{
		$state[$code] = (($rights & $value) == $value) ? TRUE : FALSE;
		$checked[$code] = ($state[$code]) ? "checked=\"checked\"" : '';
		$box[] = ($checked[$code]) ? "<img src=\"system/img/admin/discheck1.gif\" alt=\"\">" : "<img src=\"system/img/admin/discheck0.gif\" alt=\"\">";
		}

	$res = "<td style=\"text-align:center; padding:1px;\">".implode("</td><td style=\"text-align:center; padding:1px;\">", $box)."</td>\n";


	return($res);
	}

$headcol = "<td class=\"coltop\" rowspan=\"2\">".$L['Section']."</td>";
$headcol .= "<td class=\"coltop\" style=\"width:80px;\" colspan=\"".(4+$adv_columns)."\">".$L['Rights']."</td>";
$headcol .= "<td class=\"coltop\" rowspan=\"2\" style=\"width:64px;\">".$L['adm_rightspergroup']."</td>";
$headcol .= "</tr>";

$headcol .= "<tr>\n";
$headcol .= "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_r.gif\" alt=\"\"></td>\n";
$headcol .= "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_w.gif\" alt=\"\"></td>\n";
$headcol .= ($advanced) ? "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_1.gif\" alt=\"\"></td>\n" : '';
$headcol .= ($advanced) ? "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_2.gif\" alt=\"\"></td>\n" : '';
$headcol .= ($advanced) ? "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_3.gif\" alt=\"\"></td>\n" : '';
$headcol .= ($advanced) ? "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_4.gif\" alt=\"\"></td>\n" : '';
$headcol .= ($advanced) ? "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_5.gif\" alt=\"\"></td>\n" : '';
$headcol .= "<td style=\"width:24px;\" class=\"coltop\"><img src=\"system/img/admin/auth_a.gif\" alt=\"\"></td>\n";
$headcol .= "<td style=\"width:64px;\" class=\"coltop\">&nbsp;</td>\n";
$headcol .= "</tr>\n";

$sql = sed_sql_query("SELECT * FROM $db_users WHERE user_id='$id' LIMIT 1");
sed_die(sed_sql_numrows($sql)==0);
$urr = sed_sql_fetcharray($sql);

$userrights = sed_auth_build($urr['user_id'], $urr['user_maingrp']);

$sql1 = sed_sql_query("SELECT fs_id, fs_title, fs_category FROM $db_forum_sections
	WHERE 1 ORDER BY fs_order ASC, fs_title ASC");

$userrights_sec = array();

while ($row1 = sed_sql_fetcharray($sql1))
	{
	$userrights_sec['forums'][$row1['fs_id']] = $L['Forums']." ".$cfg['separator']." ".sed_cc(sed_cutstring($row1['fs_category'], 24))." ".$cfg['separator']." ".sed_cc(sed_cutstring($row1['fs_title'], 32));
	}

$userrights_sec['admin']['a'] = $L['Administration'];
$userrights_sec['comments']['a'] = $L['Comments'];
$userrights_sec['index']['a'] = $L['Home'];
$userrights_sec['message']['a'] = $L['Messages'];

$userrights_sec['pfs']['a'] = $L['PFS'];
$userrights_sec['pm']['a'] = $L['Private_Messages'];
$userrights_sec['polls']['a'] = $L['Polls'];
$userrights_sec['ratings']['a'] = $L['Ratings'];
$userrights_sec['users']['a'] = $L['Users'];


$L['adm_code']['page'] = $L['Pages'];
$L['adm_code']['plug'] = $L['Plugins'];

foreach ($sed_cat as $k => $line)
	{
	$userrights_sec['page'][$k] = $L['Pages']." ".$cfg['separator']." ".sed_build_catpath($k, "%2\$s")." (<i>$k</i>)";
	}

$adminmain = "<h4>".$L['User']." :</h4>";

$adminmain .= "<table class=\"cells\">";
$adminmain .= "<tr><td>".$L['User']." # :</td>";
$adminmain .= "<td>";
$adminmain .= "<form id=\"userrights\" action=\"admin.php?m=tools&amp;p=userrights\" method=\"post\">";
$adminmain .= "<input type=\"text\" class=\"text\" name=\"userid\" value=\"".$urr['user_id']."\" size=\"16\" maxlength=\"16\" />";
$adminmain .= " <input type=\"submit\" class=\"submit\" value=\"".$L['Submit']."\" /></form>";


$adminmain .= "</td></tr>";
$adminmain .= "<tr><td>".$L['Name']." :</td>";
$adminmain .= "<td>".sed_build_user($urr['user_id'], sed_cc($urr['user_name']))."</td></tr>";
$adminmain .= "<tr><td>".$L['Maingroup']." :</td>";
$adminmain .= "<td>".sed_build_group($urr['user_maingrp'])."</td></tr>";
$adminmain .= "<tr><td>".$L['Groups']." :</td>";
$adminmain .= "<td>".sed_build_groupsms($urr['user_id'], FALSE, $urr['user_maingrp'])."</td></tr>";
$adminmain .= "</table>";

$adminmain .= "<h4>".$L['Rights']." :</h4>";
$adminmain .= "<table class=\"cells\">";
$adminmain .= $headcol;

foreach ($userrights as $code => $line)
	{
	foreach($line as $option => $value)
		{
		$adminmain .= "<tr>";
		$adminmain .= sed_userrights_item($code, $option);
		$adminmain .= sed_userrights_rights($value);
		$adminmain .= "<td style=\"text-align:center;\">".$value."</td>";
		$adminmain .= "<td style=\"text-align:center;\"><a href=\"admin.php?m=rightsbyitem&amp;ic=".$code."&amp;io=".$option."\"><img src=\"system/img/admin/rights2.gif\" alt=\"\"></a></td>";
		$adminmain .= "</tr>";
		}

	}

$adminmain .= "</table>";

?>